#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Vram.h"

constexpr byte InvalidCode = 0xff;
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->codes[0] = InvalidCode;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    ptr<byte> pc;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pc = p->codes;
    repeat (4) {
        *pc = code;
        ++code;
        ++pc;
    }
}


void ShowSprite4(ptr<Movable> pMovable, ptr<byte> pChars)
{
    ptr<Sprite> p;
    ptr<byte> pc;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pc = p->codes;
    repeat (4) {
        *pc = *pChars;
        ++pChars;
        ++pc;
    }
}

void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->codes[0] = InvalidCode;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->codes[0] != InvalidCode) {
            ptr<byte> pVVram;
            byte y, c;
            y = p->y;
            pVVram = VVramPtr(p->x, y);
            pVVram[0] = p->codes[0]; 
            pVVram[1] = p->codes[1];
            pVVram[VVramWidth] = p->codes[2];
            pVVram[VVramWidth + 1] = p->codes[3];
        }
    }
}
