include "VVram.inc"
include "Chars.inc"

ext @Temp@Byte
ext @Temp@Word
ext @Temp@Word2
ext @Temp@Word3

ext VVram_
ext CellMap_
; ext LineRed_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

Cell_Wall equ 10h
Cell_Item equ 20h
Cell_Mask equ 0f0h


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	psha
	pshb
        ldab	VVramPtr_.y_
        aslb | aslb | aslb  ;*8
        stab <@Temp@Word+1 | clr @Temp@Word
        asl @Temp@Word+1 | rol @Temp@Word ;16
        asl @Temp@Word+1 | rol @Temp@Word ;32
        adda <@Temp@Word+1 | staa <@Temp@Word+1
        ldaa <@Temp@Word | adca #0 | staa <@Temp@Word
        ldaa <@Temp@Word+1 | adda #low VVram_ | staa <@Temp@Word+1
        ldaa <@Temp@Word | adca #high VVram_ | staa <@Temp@Word
        ldx <@Temp@Word
	pulb
	pula
rts


; void MapToVVram();
pVVram equ @Temp@Word
pCellMap equ @Temp@Word2
pChars equ @Temp@Word3

LineChars:
    defb Char_Space, Char_Space, Char_Space, Char_Space ; none
    defb Char_Line_Bottom, Char_Space, Char_Line_Top, Char_Space ; left
    defb Char_Space, Char_Line_Bottom, Char_Space, Char_Line_Top ; right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_Top, Char_Line_Top ; left right
    defb Char_Line_Right, Char_Line_Left, Char_Space, Char_Space ; top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_Top, Char_Space ; top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Space, Char_Line_Top ; top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_Top, Char_Line_Top ; top left right
    defb Char_Space, Char_Space, Char_Line_Right, Char_Line_Left ; bottom
    defb Char_Line_Bottom, Char_Space, Char_Line_RightTop, Char_Line_Left ; bottom left
    defb Char_Space, Char_Line_Bottom, Char_Line_Right, Char_Line_LeftTop ; bottom right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom left right
    defb Char_Line_Right, Char_Line_Left, Char_Line_Right, Char_Line_Left ; bottom top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_RightTop, Char_Line_Left ; bottom top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Line_Right, Char_Line_LeftTop ; bottom top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom top left right

cseg
MapToVVram_: public MapToVVram_
    psha | pshb
        ldx #VVram_ | stx <pVVram
        ldx #CellMap_ | stx <pCellMap
        ldab #MapHeight
        do
            pshb
                ldab #MapWidth
                do
                    pshb
                        ldx <pCellMap
                        ldaa 0,x | inx
                        stx <pCellMap
                        
                        cmpa #Cell_Wall
                        if eq
                            ldaa #Char_Wall
                            ldab #2
                            do
                                pshb
                                    ldx <pVVram
                                    ldab #2
                                    do
                                        staa 0,x | inx
                                        decb
                                    while ne | wend
                                    stx <pVVram
                                    psha
                                        ldaa <pVVram+1 | adda #low(VVramWidth-2) | staa <pVVram+1
                                        ldaa <pVVram | adca #high(VVramWidth-2) | staa <pVVram
                                    pula
                                pulb
                                decb
                            while ne | wend
                            bra nextCell
                        endif
                        cmpa #Cell_Item
                        if eq
                            ldaa #Char_Item
                            byChar:
                            ldab #2
                            do
                                pshb
                                    ldx <pVVram
                                    ldab #2
                                    do
                                        staa 0,x | inx
                                        inca
                                        decb
                                    while ne | wend
                                    stx <pVVram
                                    psha
                                        ldaa <pVVram+1 | adda #low(VVramWidth-2) | staa <pVVram+1
                                        ldaa <pVVram | adca #high(VVramWidth-2) | staa <pVVram
                                    pula
                                pulb
                                decb
                            while ne | wend
                            bra nextCell
                        endif
                        anda #$0f
                        asla | asla
                        adda #low LineChars | staa <pChars+1
                        ldaa #high LineChars | adca #0 | staa <pChars 
                        ldab #2
                        do
                            pshb
                                ldab #2
                                do
                                    ldx <pChars
                                    ldaa 0,x | inx
                                    stx <pChars
                                    cmpa #Char_Space
                                    ; if ne
                                    ;     tst LineRed_
                                    ;     if ne
                                    ;         adda #Char_Line_Red-Char_Line_Normal
                                    ;     endif
                                    ; endif
                                    ldx <pVVram
                                    staa 0,x | inx
                                    stx <pVVram
                                    decb
                                while ne | wend
                                ldaa <pVVram+1 | adda #low(VVramWidth-2) | staa <pVVram+1
                                ldaa <pVVram | adca #high(VVramWidth-2) | staa <pVVram
                            pulb
                            decb
                        while ne | wend
                        nextCell:
                        ldaa <pVVram+1 | adda #low(2-VVramWidth*2) | staa <pVVram+1
                        ldaa <pVVram | adca #high(2-VVramWidth*2) | staa <pVVram
                    pulb
                    decb
                while ne | wend
                ldaa <pVVram+1 | adda #low VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #high VVramWidth | staa <pVVram
            pulb
            decb
        while ne | wend        
    pulb | pula
rts


; ; void DrawBackGround();
; cseg
; DrawBackGround_: public DrawBackGround_
;     psha | pshb
;         ldx #VVram_
;         ldaa #Char_Roof_Left | staa 0,x | inx
;         ldaa #Char_Roof_Center
;         ldab #VVramWidth-2
;         do
;             staa 0,x | inx
;             decb
;         while ne | wend
;         ldaa #Char_Roof_Right | staa 0,x | inx

;         ldaa #Char_Roof_Center
;         ldab #VVramWidth
;         do
;             staa 0,x | inx
;             decb
;         while ne | wend

;         stx <@Temp@Word
;         ldx #CellMap_ | stx <@Temp@Word2
;         ldab #5
;         do
;             pshb
;                 ldab #16
;                 do
;                     ldx <@Temp@Word2
;                     ldaa 0,x | inx
;                     stx <@Temp@Word2

;                     anda #Cell_Type_LiftBottom
;                     cmpa #Cell_Type_LiftBottom
;                     if eq
;                         ldaa #Char_LiftBottom
;                     else
;                         anda #Cell_Type_Floor
;                         if ne
;                             ldaa #Char_Floor
;                         else
;                             ldaa #Char_Space
;                         endif
;                     endif
                    
;                     ldx <@Temp@Word
;                     clr 0,x
;                     clr 1,x
;                     clr VVramWidth,x
;                     clr VVramWidth+1,x
;                     clr VVramWidth*2,x
;                     clr VVramWidth*2+1,x
;                     staa VVramWidth*3,x
;                     staa VVramWidth*3+1,x
;                     inx | inx | stx <@Temp@Word

;                     decb
;                 while ne | wend

;                 ldaa <@Temp@Word+1 | adda #low VVramWidth*3 | staa <@Temp@Word+1
;                 ldaa <@Temp@Word | adca #high VVramWidth*3 | staa <@Temp@Word
;             pulb
;             decb
;         while ne | wend
;     pulb | pula
; rts
